
var arrayBuffer;
var startTime;
var finished;
function getGeoCont(file)
{
    var xhr = new XMLHttpRequest();
    xhr.open("GET", file, true);
    xhr.responseType = 'arraybuffer';
    xhr.onloadend = function(){
        if(xhr.responseType == 'arraybuffer')
        {
            startTime = new Date().getTime();
            arrayBuffer = this.response;
            document.renderer.tick();
        }
    }
    xhr.send();
}

var simRate = 2000;
function simProg()
{
    if(!arrayBuffer || finished)return;
    var time = new Date().getTime();
    var maxLength = arrayBuffer.byteLength;
    var bytes = (time-startTime) * simRate;
    //console.log(bytes+" "+maxLength);
    bytes = Math.min(bytes-bytes%4, maxLength);
    console.log("test " + bytes);
    if(bytes <= maxLength){
        if(bytes == maxLength)finished = true;
        var newBuf = arrayBuffer.slice(0, bytes);
        parseAB(newBuf);
        updateOSD(bytes/maxLength);
        document.getElementById("inner").style.width = bytes/maxLength*1024+"px";
        updateOSDBytes(bytes, maxLength);
    }

}

var headerStore;
function parseAB(arrayBuffer)
{
    if(parseHeader(arrayBuffer))
    {
        splitBody(headerStore, arrayBuffer);
    }
}

function ab2str(buf) {
    return String.fromCharCode.apply(null, new Uint8Array(buf));
}

function parseHeader(arrayBuffer)
{
    if(arrayBuffer.byteLength < 8)
    {
        return false;
    }
    if(headerStore)
    {
        return headerStore;
    }
    var header = {};
    var dv = new DataView(arrayBuffer);
    var headerLength = dv.getInt32(4, true);

    if(headerLength <= arrayBuffer.byteLength - 8)//if header is complete
    {
        var headerString = ab2str(arrayBuffer.slice(8, headerLength+8));
        header = JSON.parse(headerString);
        header.chunkOffset = headerLength + 8;
        log("header parsed");
        headerStore = header;
        document.renderer.createBuffers(headerStore);
        setupOSD(header);
    }
    return headerStore;
}

var parsedChunks = [];

function splitBody(header, arrayBuffer)
{
    Object.keys(header.bufferChunks).forEach(function(key){
        //if chunk already parsed: skip
        if(parsedChunks.indexOf(key) == -1)
        {
            //TODO order of chunks?
            var chunkDesc = header.bufferChunks[key];
            var chunkStart = header.chunkOffset + chunkDesc.byteOffset;
            var chunkEnd = chunkStart + chunkDesc.byteLength;
            //if chunk not completed: skip
            if(chunkEnd  <= arrayBuffer.byteLength)
            {
                //add chunk
                var chunk = new Uint8Array(arrayBuffer, chunkStart, chunkEnd - chunkStart);
                log("addChunk " + key);
                parsedChunks.push(key);
                document.renderer.addChunk(key, chunk);
            }
        }

    });

    //TEXTURE TESTING
//    var  xmlhttp = new XMLHttpRequest();
//    xmlhttp.responseType = 'arraybuffer';
//    xmlhttp.onloadend = function() {
//        document.renderer.addTex("", {textureBuffer: xmlhttp.response});
//    };
//    xmlhttp.open('GET', 'duck.png', true);
//    xmlhttp.send(null);
    //
}

function getChunkType(header, chunkName)
{
    for(var i = 0; i < Object.keys(header.bufferViews).length; i++)
    {
        var bufferView = header.bufferViews[Object.keys(header.bufferViews)[i]];
        for(var c = 0; c < bufferView.chunks.length; c++)
        {
            if(bufferView.chunks[c] == chunkName)
            {
                return "bufferChunk";
            }
        }
    }
    for(var i = 0; i < Object.keys(header.textureViews).length; i++)
    {
        var textureView = header.textureViews[Object.keys(header.textureViews)[i]];
        for(var c = 0; c < textureView.chunks.length; c++)
        {
            if(textureView.chunks[c] == chunkName)
            {
                return "textureChunk";
            }
        }
    }
}

var OSDChunks = {};

var bufferChunksLoaded = 0;
var textureChunksLoaded = 0;

var numBufferChunks = 0;
var numTextureChunks = 0;

function setupOSD(header)
{

    //LOADING BAR
    var osd_bar_outer = document.getElementById("osd_bar_outer");
    var osd_bar_inner = document.getElementById("osd_bar_inner");
    var osd_shadow_box = document.getElementById("osd_shadow_box");
    var rel_bar_width = 0.8;
    var canvas = document.getElementById("myCanvas");
    var offset = canvas.getBoundingClientRect();
    var bar_border = 1;

    var bar_width = Math.ceil(rel_bar_width * canvas.width);
    var bar_height = 30;
    var bar_offset_x = (1 - rel_bar_width) / 2.0 * canvas.width + offset.left -1;
    var bar_offset_y = Math.ceil(0.02 * canvas.height) + offset.top-1;

    osd_bar_outer.style.height = bar_height + "px";
    osd_bar_outer.style.width = bar_width + "px";
    osd_bar_outer.style.top = bar_offset_y + "px";
    osd_bar_outer.style.left = bar_offset_x + "px";
    //osd_bar_outer.style.border = bar_border + "px " + bar_border + "px 0px " + bar_border + "px" + " solid black";
    osd_bar_outer.style.border = bar_border + "px solid black";
    osd_bar_outer.style.borderBottom = "0px solid black";

    osd_bar_inner.style.height = bar_height + "px";
    osd_bar_inner.style.width = "1px";
    osd_bar_inner.style.top = bar_offset_y + "px";
    osd_bar_inner.style.left = bar_offset_x + "px";
    osd_bar_inner.style.border = bar_border + "px solid black";
    osd_bar_inner.style.borderBottom = "0px solid black";
    osd_bar_inner.style.borderRight = "0px solid black";




    //CHUNK BAR
    var bufferLength = 0;
    for(var i = 0; i < Object.keys(header.bufferChunks).length; i++)
    {
        var chunk = header.bufferChunks[Object.keys(header.bufferChunks)[i]];
        bufferLength += chunk.byteLength;
    }

    var unusedBufferLength = bufferLength;
    var minimumPixelWidth = 50;
    var xpos = 0;
    var ypos =  osd_bar_outer.offsetHeight;
    var chunkHeight = 30;
    var borderSize = 1;
    var borderRadius = 0;
    var body = document.getElementsByTagName("body")[0];

    for(var i = 0; i < Object.keys(header.bufferChunks).length; i++)
    {
        var chunksLeft = Object.keys(header.bufferChunks).length - i;
        var chunkName = Object.keys(header.bufferChunks)[i];
        var chunkByteLength = header.bufferChunks[chunkName].byteLength;
        var chunkType = getChunkType(header, chunkName);
        var ele = document.createElement("DIV");
        body.appendChild(ele);
        ele.className = chunkType + " chunkDiv";
        ele.className = chunkType + " chunkDiv unclassifiedChunk";
        var chunkPixelLength = chunkByteLength / unusedBufferLength * (bar_width - xpos - (minimumPixelWidth * chunksLeft) - borderSize + bar_border*2) + minimumPixelWidth;
        ele.style.width = chunkPixelLength - borderSize + "px";
        ele.style.height = chunkHeight + "px";
        ele.style.border = borderSize + "px solid black";
        ele.style.borderRadius = borderRadius + "px";
        ele.style.left = bar_offset_x + xpos + "px";
        ele.style.top = bar_offset_y + ypos + "px";
        xpos += chunkPixelLength;
        unusedBufferLength -= chunkByteLength;
        OSDChunks[chunkName] = ele;
    }


    osd_shadow_box.style.left = osd_bar_outer.offsetLeft + "px";
    osd_shadow_box.style.width = osd_bar_outer.clientWidth + "px";
    osd_shadow_box.style.top = osd_bar_outer.offsetTop + "px";
    osd_shadow_box.style.height = osd_bar_outer.clientHeight + chunkHeight + borderSize * 2 + "px";


    //COUNTER
    for(var i = 0; i < Object.keys(header.bufferViews).length; i++)
    {
        var bufferView = header.bufferViews[Object.keys(header.bufferViews)[i]];
        numBufferChunks += bufferView.chunks.length;
    }
    for(var i = 0; i < Object.keys(header.textureViews).length; i++)
    {
        var textureView = header.textureViews[Object.keys(header.textureViews)[i]];
        numTextureChunks += textureView.chunks.length;
    }
    updateOSDChunkString();
    var counterGeo = document.getElementById("osd_counter_geo");
    var counterTex = document.getElementById("osd_counter_tex");
    var counterTop = 90;
    var counterDistance = 40;
    var counterLeft = (canvas.width - (counterGeo.offsetWidth + counterDistance + counterTex.offsetWidth)) / 2;


    counterGeo.style.left = offset.left + counterLeft + "px";
    counterGeo.style.top = bar_offset_y + counterTop + "px";
    counterTex.style.left = offset.left + counterLeft + counterGeo.offsetWidth + counterDistance + "px";
    counterTex.style.top = bar_offset_y + counterTop + "px";

    updateOSDBytes(0, 0)



}


function updateOSD(percent)
{
    var osd_bar_inner = document.getElementById("osd_bar_inner");
    var osd_bar_outer = document.getElementById("osd_bar_outer");
    var width = percent * parseFloat(osd_bar_outer.style.width.slice(0, -2));
    osd_bar_inner.style.width = width + "px";
}

function updateOSDBytes(bytes, maxLength)
{
    var counter = document.getElementById("osd_counter_bytes");
    var osd_bar_outer = document.getElementById("osd_bar_outer");
    counter.innerHTML = Math.round(bytes / 1024) + " / " + Math.round(maxLength / 1024) + " KB";
    var counterBytesOffset_x = (osd_bar_outer.offsetWidth - counter.offsetWidth) / 2;
    var counterBytesOffset_y = (osd_bar_outer.offsetHeight - counter.offsetHeight) / 2;
    counter.style.left = osd_bar_outer.offsetLeft + counterBytesOffset_x + "px";
    counter.style.top = osd_bar_outer.offsetTop + counterBytesOffset_y + "px";
}

function updateOSDChunks(chunkName)
{
    var ele = OSDChunks[chunkName];
    if(ele.className.indexOf("textureChunk") >= 0)
    {
        textureChunksLoaded++;
    }
    else
    {
        bufferChunksLoaded++;
    }
    //remove unclassified to color the chunkDiv
    ele.className = ele.className.slice(0, ele.className.indexOf(" unclassifiedChunk"));

    //counter
    updateOSDChunkString();

}

function updateOSDChunkString()
{
    var counterGeo = document.getElementById("osd_counter_geo");
    var counterTex = document.getElementById("osd_counter_tex");
    counterGeo.innerHTML = "Geometry Chunks: " + bufferChunksLoaded + " / " + numBufferChunks;
    counterTex.innerHTML = "Texture Chunks: " + textureChunksLoaded + " / " + numTextureChunks;
}


function log(text)
{
    document.getElementById("log").innerHTML += text+"<br/>";
}